Subject: Re: [RFC PATCH 0/7] pack-bitmap: resolve various `--path-walk` incompatibilities

From: Derrick Stolee <[email-masked]>
Date: Mon, 4 May 2026 08:13:30 -0400

On 5/3/2026 8:11 PM, Taylor Blau wrote:
> (Note to the maintainer, this is built on top of 'ds/path-walk-filters').
> 
> Between other tasks, I have been working on trying to integrate
> `--path-walk` within GitHub's infrastructure. In order to do this,
> `--path-walk` must work with features that GitHub depends on, such as
> reachability bitmaps and delta-islands (along with filters, shallow,
> etc., though more on that below).
> 
> I had been sitting on these patches for a few days in my fork before
> Stolee sent his series in [1] which resolves incompatibilities between
> the `--path-walk` option and various filter types. Since I figured that
> others are working in this area I wanted to send a reworked version of
> my series for a couple of reasons:
> 
>  1. Since reviewers are already looking at this area as a consequence of
>     Stolee's series, this topic should be slightly easier to review
>     while the area is fresh.

I agree that we should review both series together. It's been a while
since the original path-walk API series, so it may require some refresh
of all its nuances.
 
>  2. In case Stolee (or others) are working on resolving the
>     incompatibility between `--path-walk` and either delta-islands or
>     reachability bitmaps, this series can either combine with those (if
>     any) or serve as inspiration (if others are in the process of
>     writing such series).

I was _not_ working on bitmap compatibility, but I'm grateful to see it!
> When writing this originally, I had borrowed the same filter-application
> mechanism from bitmaps, which supports trivial filters (e.g., blob:none,
> tree:0, and combinations therein). Stolee's series is a strict
> improvement on that approach supporting sparse:<oid> filters as well, so
> I reworked my filtering-related patches based on that.

You have some new filters that I had not considered, so they are welcome
additions. If you don't mind, I could add them into my series, as they
may be more appropriate grouped with the other filter changes. 
> The patches surrounding bitmaps and delta-islands are largely
> unchanged from when I had originally written them:
> 
>  * Supporting bitmaps with `--path-walk` is mostly straightforward, and
>    boils down to ensuring that the path-walk-specific object callback
>    indexes any commit(s) it sees for bitmapping.
> 
>  * Supporting delta-islands with `--path-walk` required a bit more
>    surgery, and involves propagating island marks for commits in the
>    path-walk-specific callback, as well as recording tree depth
>    information in the same spot.
> 
> I'm submitting these patches as an RFC, since (a) I haven't thought
> deeply about the approach taken here and could very well be on the wrong
> track, and (b) in case Stolee or others want to combine forces here
> and/or coordinate around each other.

I'll definitely take a very close read of these patches, as there are
some interesting interactions here.

Thanks,
-Stolee